/*
 * Copyright (C) 2010 Teleal GmbH, Switzerland
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.teleal.cling.test.data;

import org.teleal.cling.model.meta.Device;
import org.teleal.cling.model.meta.DeviceIdentity;
import org.teleal.cling.model.meta.DeviceService;
import org.teleal.cling.model.meta.LocalDeviceService;
import org.teleal.cling.model.meta.Service;

/**
 * @author Christian Bauer
 */
public class SampleDeviceEmbeddedOneLocal extends SampleDeviceEmbeddedOne {

    public SampleDeviceEmbeddedOneLocal(DeviceIdentity identity, Service service, Device[] embeddedDevices) {
        super(identity, service, embeddedDevices);
    }

    @Override
    public DeviceService[] getDeviceServices() {
        return new DeviceService[]{
                new LocalDeviceService(
                        getServiceTwoType(),
                        getServiceTwoId(),
                        null
                )
        };
    }

}
