/*
 * Copyright (C) 2010 Teleal GmbH, Switzerland
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.teleal.cling.support.avtransport.impl;

import org.teleal.cling.support.avtransport.dto.SeekMode;
import org.teleal.cling.support.avtransport.impl.state.AbstractState;
import org.teleal.cling.support.avtransport.impl.state.NoMediaPresent;
import org.teleal.cling.support.avtransport.impl.state.PausedPlay;
import org.teleal.cling.support.avtransport.impl.state.Playing;
import org.teleal.cling.support.avtransport.impl.state.Stopped;
import org.teleal.common.statemachine.StateMachine;
import org.teleal.common.statemachine.States;

@States({
        NoMediaPresent.class,
        Stopped.class,
        Playing.class,
        PausedPlay.class
})
public interface AVTransportStateMachine extends StateMachine<AbstractState> {

    public abstract void setTransportURI(String uri, String uriMetaData);
    public abstract void setNextTransportURI(String uri, String uriMetaData);
    public abstract void stop();
    public abstract void play(String speed);
    public abstract void pause();
    public abstract void record();
    public abstract void seek(SeekMode unit, String target);
    public abstract void next();
    public abstract void previous();

}
